#include <pololu/3pi.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <stdlib.h>
#include "followSeg.h"
#include "turn.h"
#include "turnH.h"
#include "Home.h"

/***********************************************************/

void initialize();

/***********************************************************/

const char welcome_line1[] PROGMEM = " Pololu";
const char welcome_line2[] PROGMEM = "3\xf7 Robot";
const char demo_name_line1[] PROGMEM = " Final ";
const char demo_name_line2[] PROGMEM = "Project";
//Simple Tune
const char welcome[] PROGMEM = ">g32>>c32";

/***********************************************************/

int main() {
int start = 0;
int i;
int len;

initialize();

while(1) {

  switch(start) {
//---------To ---------//
	case 0:
//	      lcd_goto_xy(0,1);
// 	 	  print("0");
		  followSeg();
  		  char dir0[] = {'S','S','L','S','B','S','R','S','S','B'};
  		  len = 10;
  		  for(i=0; i<len; i++) {
    	    turn(dir0[i]);
  		  }
		  start=1;
		  break;

//---------To ---------//
	case 1:
//	      lcd_goto_xy(0,1);
// 	 	  print("0");
		  followSeg();
  		  char dir1[] = {'S','S','R','S','L','S','S','S','L'};
  		  len = 9;
  		  for(i=0; i<len; i++) {
    	    turn(dir1[i]); 
  		  }
		  start=2;
		  break;

//---------To ---------//
	case 2:
//	      lcd_goto_xy(0,1);
// 	 	  print("0");
		  followSeg();
  		  char dir2[] = {'S','S','S','B','S','S','S','R','S','S'};
  		  len = 10;
  		  for(i=0; i<len; i++) {
    	    turn(dir2[i]); 
  		  }
		  start=3;
		  break;

//---------To ---------//
	case 3:
//	      lcd_goto_xy(0,1);
// 	 	  print("0");
		  followSeg();
  		  char dir3[] = {'S','R','S','L','S','S','B','S','S'};
  		  len = 9;
  		  for(i=0; i<len; i++) {
    	    turn(dir3[i]); 
  		  }
		  start=4;
		  break;

//---------To ---------//
	case 4:
//	      lcd_goto_xy(0,1);
// 	 	  print("0");
		  followSeg();
  		  char dir4[] = {'L','S','B','S','R','S','S','B','S','S'};
  		  len = 10;
  		  for(i=0; i<len; i++) {
    	    turn(dir4[i]); 
  		  }
		  start=5;
		  break;

//---------To ---------//
	case 5:
//	      lcd_goto_xy(0,1);
// 	 	  print("0");
		  followSeg();
  		  char dir5[] = {'R','S','L','S','S','S','S','L','S','S'};
  		  len = 10;
  		  for(i=0; i<len; i++) {
    	    turn(dir5[i]); 
  		  }
		  start=6;
		  break;

//---------To ---------//
	case 6:
//	      lcd_goto_xy(0,1);
// 	 	  print("0");
		  followSeg();
  		  char dir6[] = {'S','B','S','S','S','R','S','S','S','S'};
  		  len = 10;
  		  for(i=0; i<len; i++) {
    	    turn(dir6[i]); 
  		  }
		  start=7;
		  break;

//---------To ---------//
	case 7:
//	      lcd_goto_xy(0,1);
// 	 	  print("0");
		  followSeg();
  		  char dir7[] = {'R','S','L','S','S','B','R','S','L','S'};
  		  len = 10;
  		  for(i=0; i<len; i++) {
    	    turn(dir7[i]); 
  		  }
		  start=8;
		  break;

//---------To ---------//
	case 8:
//	      lcd_goto_xy(0,1);
// 	 	  print("0");
		  followSeg();
  		  char dir8[] = {'S','S','S','S','S','S','S','S','S','S'};
  		  len = 10;
  		  for(i=0; i<len; i++) {
    	    turn(dir8[i]); 
  		  }
		  start=9;
		  break;

//---------To ---------//
	case 9:
//	      lcd_goto_xy(0,1);
// 	 	  print("0");
		  followSeg();
  		  char dir9[] = {'L','S','S','S','B','S','S','S','R','S'};
  		  len = 10;
  		  for(i=0; i<len; i++) {
    	    turn(dir9[i]); 
  		  }
		  start=10;
		  break;

//---------To ---------//
	case 10:
//	      lcd_goto_xy(0,1);
// 	 	  print("0");
		  followSeg();
  		  char dir10[] = {'S','S','S','S','S','S','S','S','S','R'};
  		  len = 10;
  		  for(i=0; i<len; i++) {
    	    turn(dir10[i]); 
  		  }
		  start=11;
		  break;

//---------To ---------//
	case 11:
//	      lcd_goto_xy(0,1);
// 	 	  print("0");
		  followSeg();
  		  char dir11[] = {'S','L','B','S','S','S','R','S','L','S'};
  		  len = 10;
  		  for(i=0; i<len; i++) {
    	    turn(dir11[i]); 
  		  }
		  start=12;
		  break;

//---------To ---------//
	case 12:
//	      lcd_goto_xy(0,1);
// 	 	  print("0");
		  followSeg();
  		  char dir12[] = {'S','S','S','S','S','S','S','L','S','S'};
  		  len = 10;
  		  for(i=0; i<len; i++) {
    	    turn(dir12[i]); 
  		  }
		  start=13;
		  break;

//---------To ---------//
	case 13:
//	      lcd_goto_xy(0,1);
// 	 	  print("0");
		  followSeg();
  		  char dir13[] = {'S','B','S','S','S','R'};
  		  len = 6;
  		  for(i=0; i<len; i++) {
    	    turn(dir13[i]); 
  		  }
		  start=14;
		  break;

//--------- ---------//
	case 14:
//	      lcd_goto_xy(0,1);
// 	 	  print("0");
		  Home();
  		  char dir14[] = {'S','S','S','S','S','S','S','S'};
  		  len = 8;
  		  for(i=0; i<len; i++) {
    	    turnH(dir14[i]); 
  		  }
		  start=15;
		  break;

//---------To ---------//
	case 15:
//	      lcd_goto_xy(0,1);
// 	 	  print("0");
		  followSeg();
  		  char dir15[] = {'R','S','L','S','S','S'};
  		  len = 6;
  		  for(i=0; i<len; i++) {
    	    turn(dir15[i]); 
  		  }
		  start=16;
		  break;

//---------STOP---------//
	case 16:
//	      lcd_goto_xy(0,1);
// 	 	  print("0");
		  followSeg();
  		  char dir16[] = {'B'};
  		  len = 1;
  		  for(i=0; i<len; i++) {
    	    turn(dir16[i]); 
  		  }
		  start=99;
		  break;		 
  		   
  default:
         set_motors(0,0);
		 initialize();
		 start = 0;
		 break;
  }
			
}

}

/***********************************************************/
void initialize() {
  unsigned int counter;
  unsigned int sensors[5];

  pololu_3pi_init(2000);
	
  print_from_program_space(welcome_line1);
  lcd_goto_xy(0,1);
  print_from_program_space(welcome_line2);
  play_from_program_space(welcome);
  delay_ms(1000);
  clear();

  print_from_program_space(demo_name_line1);
  lcd_goto_xy(0,1);
  print_from_program_space(demo_name_line2);
  delay_ms(1000);
  
  while(!button_is_pressed(BUTTON_B)) {
    int bat = read_battery_millivolts();
    clear();

    print_long(bat);
    print("mV");
    lcd_goto_xy(0,1);
    print("Press B");
    delay_ms(100);
  }

  wait_for_button_release(BUTTON_B);
  delay_ms(1000);
  
  for(counter=0;counter<80;counter++) {
    if(counter < 20 || counter >= 60)
      set_motors(40,-40);
    else
      set_motors(-40,40);
    calibrate_line_sensors(IR_EMITTERS_ON);
    delay_ms(20);
  }
  set_motors(0,0);

  while(!button_is_pressed(BUTTON_B)) {
    unsigned int position = read_line(sensors,IR_EMITTERS_ON);
    clear();

    print_long(position);
    lcd_goto_xy(0,1);
    delay_ms(100);
  }
  wait_for_button_release(BUTTON_B);
  clear();

  print("Go!");
}
